//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Board.h"

/*
   ,    
       
.   8  .
     .
 -     ,  -   ..
*/
const int vert[] = {0,-1,-1,-1,0,1,1,1};
const int hor[] = {1,1,0,-1,-1,-1,0,1};
//---------------------------------------------------------------------------
Board::Board()
{
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 8; j++)
      accessible[i][j] = true;
}
//---------------------------------------------------------------------------
bool Board::SetQueen(const int x, const int y)
{
  if(x<0 || x>7 || y<0 || y>7 || accessible[x][y]==false)
    return false;
  accessible[x][y] = false;
  for(int i = 0; i<8; i++)    //  
    for(int j = 0; j<8; j++)  //    
      {
        int movH = x + hor[i]*(j+1);
        int movV = y + vert[i]*(j+1);
        if(movH>=0 && movH<8 && movV>=0 && movV<8)
          accessible[movH][movV] = false;
        else break;
      }
  return true;
}
//---------------------------------------------------------------------------
int Board::TestSquare(const int x, const int y)
{
  if(x<0 || x>7 || y<0 || y>7 || accessible[x][y]==false)
    return 0;
  int count = 1;
  for(int i = 0; i<8; i++)    //  
    for(int j = 0; j<8; j++)  //    
      {
        int movH = x + hor[i]*(j+1);
        int movV = y + vert[i]*(j+1);
        if(movH<0 || movH>7 || movV<0 || movV>7)
          break;
        else if(accessible[movH][movV]==true) count++;
      }
  return count;
}
//---------------------------------------------------------------------------

#pragma package(smart_init)
